Bug 468145 - regression: definition of system-.h-declared function disables all warnings
regression: definition of system-.h-declared function disables all warnings
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: gcc4 (Show other bugs)
10
All Linux
low Severity low
: ---
: ---
Assigned To: Jakub Jelinek
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-10-23 03:56 EDT by Jim Meyering
Modified: 2013-03-13 16:40 EDT (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-12-18 01:38:00 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Jim Meyering 2008-10-23 03:56:09 EDT
Description of problem:
When I define a function that is already declared in a system header
file (same signature, of course), all warnings are disabled not only
in that function, but any following function definitions in the same
compilation unit.

Version-Release number of selected component (if applicable): 4.3 and the latest in rawhide: gcc (GCC) 4.3.2 20081007 (Red Hat 4.3.2-6)


How reproducible: always


Steps to Reproduce:
For example, with this code,

cat <<'EOF' > k.c
#include <stdlib.h>
int clearenv (void) {}
int bar (int i) { return 0; int j; return j; }
EOF

I would expect compiling with -W -Wall -Wdeclaration-after-statement
to warn about the decl-after-stmt and the unused parameter, but get
neither:

    $ gcc -O -W -Wall -Wdeclaration-after-statement -c k.c       

    $ gcc --version
    gcc (GCC) 4.3.2 20081007 (Red Hat 4.3.2-6)

gcc-4.2 does what I expect:

    $ gcc-4.2 -c -O -W -Wall -Wdeclaration-after-statement random_r.c 
    random_r.c: In function 'srandom_r':
    random_r.c:4: warning: unused parameter 'seed'
    random_r.c:4: warning: unused parameter 'buf'
    random_r.c: In function 'bar':
    random_r.c:15: warning: ISO C90 forbids mixed declarations and code
    random_r.c:15: warning: unused variable 'i'

  

Actual results:


Expected results:


Additional info:
FYI, this is not theoretical.  It bit me while writing gnulib's random_r module: the replacement implementation of srandom_r made it so legitimate warnings about code in subsequent functions were suppressed.
Comment 1 Bug Zapper 2008-11-25 23:08:43 EST
This bug appears to have been reported against 'rawhide' during the Fedora 10 development cycle.
Changing version to '10'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 2 Bug Zapper 2009-11-18 07:39:20 EST
This message is a reminder that Fedora 10 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 10.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '10'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 10's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 10 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 3 Bug Zapper 2009-12-18 01:38:00 EST
Fedora 10 changed to end-of-life (EOL) status on 2009-12-17. Fedora 10 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.